/***********************************************************************/
/*                                                                     */
/*  FILE        :USB_Drv.c                                             */
/*  UPDATE      :THU, Sep 16, 2010                                     */
/*  CREATE      :Wed, Sep 03, 2009                                     */
/*  DESCRIPTION :USB Function                                          */
/*  CPU TYPE    :H8SX/1655                                             */
/*  Created		:Yoshikazu Morita (d:Frontia)                          */
/*                                                                     */
/***********************************************************************/
#include <machine.h>

#include "typedefine.h"
#include "iodefine.h"
#include "USB_Drv.h"


const _UBYTE StandardDeviceDescriptor[] =
{
	18,			//fBXNv^̃TCY
	 1,			//foCXfBXNv^
	0x00,0x02,	//ΉUSBKi(USB 2.00)
	0xFF,		//foCXNX    i FFh ) <-x_[ɃfoCXNXۂɎgpeFĂFF𗘗pB
	0x00,		//foCXTuNX ( 00h ) <-00hƂB
	0x00,		//foCXvgR ( 00h )
	0x08,		//Endpoint 0̍őpPbgTCY <-H8SX̃n[hEGAɈˑ
	0x22,0x03,	//x_[ID			<-0322h( 802) {USB-IF̔FKvłB
	0x0A,0x00,	//v_NgID			<-000Ah(  10) ̓x_[ŎRɗpł܂B
	0x00,0x01,	//foCXo[WNo	<-0100h(1.00)
	0x00,		//\CfbNX
	0x00,		//i\CfbNX
	0x00,		//foCXVANo
	0x01,		//ėpZbg{bNX̃eiXNo
};


//Get_Descrpition(Configration)ɂāA3̃ZNVđMׁA
//RtBO[VAC^[tFCXAGh|Cg̕т͕ςĂ͂ȂB

//WRtBO[VfBXNv^
const _UBYTE StandardConfigurationDescriptor[] =
{
	 9,			//fBXNv^̃TCY
	 2,			//RtBM[VfBXNv^
	0x20,0x00,	//ȉɑAInterfaceƁAEndpoint̃fBXNv^̍vTCY
	0x01,		//gpInterface̐
	0x01,		//SetConfigurationœConfigurationDescriptorʂۂID O͕s
	0x00,		//Configuration镶IDi0Ŗwj
	0x80,		//ݒ 7bitڂ͕K1A 6bitڂ̓Ztp[=1 oXp[=0
	0xC8,		//oX狟d1/2imA) 400mA
};

const _UBYTE StandardInterfaceDescriptor[] =
{
//WC^[tFCXfBXNv^
	 9,			//fBXNv^̃TCY
	 4,			//RtBM[VfBXNv^
	 0,			//Interface΁AIDi͂Ȃ̂łO)
	 0,			//ID̕InterfacerIɎgɗpi͂Ȃ̂łOj
	 2,			//Endpoint̐(Default Endpoint = Endpoint 0͐ɓȂBj
	0x00,		//InterfaceClassIDKvȃfoCXNXł͂ɋLqB
	0x00,		//InterfaceɃTuClassIDKvȃfoCXNXł͂ɋLqB
	0x00,		//InterfaceClassIDꍇAKvɉėvvgRԍ
	 0,			//Interface̐ԍi΂Oj
};
//WGh|C^fBXNv^
const _UBYTE StandardEndpointDescriptor1[] =
{
	//Endpoint 1 ̒`
	 7,			//fBXNv^̃TCY
	 5,			//RtBM[VfBXNv^
	0x01,		//EndPoint1(out)H8USBt@NṼn[hEGA\ɈˑĂB
	0x02,		//Bulk]      H8USBt@NṼn[hEGA\ɈˑĂB
	0x40,0x00,	//őpPbg@H8USBt@NVɈˑĂB
	0xFF,		//ő҂
};
//WGh|C^fBXNv^
const _UBYTE StandardEndpointDescriptor2[] =
{	//Endpoint 2 ̒`
	 7,			//fBXNv^̃TCY
	 5,			//RtBM[VfBXNv^
	0x82,		//EndPoint2(in)  H8USBt@NṼn[hEGA\ɈˑĂB
	0x02,		//Bulk]       H8USBt@NṼn[hEGA\ɈˑĂB
	0x40,0x00,	//őpPbg@H8USBt@NVɈˑĂB
	0xFF,		//ő҂
};





//Gh|Cg񃌃WX^̐ݒe[u
//ɁAUSBW[ EPIR ʂēo^KvB
const _UBYTE EndPointInfo[5*10] =
{
	//1EndPoint5Byte X 10̐ݒ肪Kv
	0x00,0x00,0x10,0x00,0x00,	//EP0 = Control In/Out 8byte FIFO=0
	0x14,0x20,0x80,0x00,0x01,	//EP1 = Bulk Out 64byte	FIFO=1
	0x24,0x28,0x80,0x00,0x02,	//EP2 = Bulk In  64byte FIFO=2

	0x00,0x00,0x00,0x00,0x00,	//Dummy
	0x00,0x00,0x00,0x00,0x00,	//Dummy
	0x00,0x00,0x00,0x00,0x00,	//Dummy
	0x00,0x00,0x00,0x00,0x00,	//Dummy
	0x00,0x00,0x00,0x00,0x00,	//Dummy
	0x00,0x00,0x00,0x00,0x00,	//Dummy
	0x00,0x00,0x00,0x00,0x00,	//Dummy
};


//SetupCommand̃tH[}bgizXgj
union {
	_UBYTE Buf[8];
	struct {
		struct {
			_UBYTE DataTransferDirection :1;
			_UBYTE Type                  :2;
			_UBYTE Recipient			 :5;
		}	bmRequestType;
		_UBYTE	bRequest;
		_UWORD	wValue;
		_UWORD	wIndex;
		_UWORD	wLength;
	} Format;
} SetupCommand;
union uni_USB_Proc_Flag USB_Proc_Flag;

//EndPoint0 SetupCommandn̎Mpobt@
_UBYTE ControlCommandBuf[8];
//EndPoint0̎OMobt@(EP0 FIFO8Byte܂łȂ̂ŎOobt@Kv)
_UBYTE * ptrEP0i_Buf;
//EndPoint0̎OMobt@ɎcĂvMf[^TCY
int		 sizeEP0i_Buf;


//EndPoint1 Mp[vobt@iI[o[̌؂͂ĂȂj
#define  RcvLimit 256
_UBYTE RcvBuf[RcvLimit];
int RcvStorePoint =0;
int RcvExtractPoint =0;

//EndPoint2 Mp
_UBYTE *ptrSendPos;
int  RemainSendSize;


//EndPoint0(in)ɑ΂đMsB(2pPbgڈȍ~j
void SendEP0iNext(void)
{
	int	FIFOcnt = 8;
	//EP0(in)FIFOobt@8byte͈̔͂ŎOMobt@瑗Mf[^𑗂B
	while( FIFOcnt-- > 0 )
	{
		if( sizeEP0i_Buf-- > 0 )
		{
			//OMobt@ɖMf[^cĂ΁AFIFO֑B
			USB.EPDR0i = *ptrEP0i_Buf ++;
		}
		else
		{
			//OMobt@̓eSđ瑗MԂ甲B
			//(AFIFO͖Ȃ̂Ŗ{̈Ӗł͂܂M͊ĂȂBj
			//EP0(in)̑MtONA
			USB_Proc_Flag.BIT.EP0iSending = 0;
		}
	}
	//EP0(in)̑MJnB
	USB.TRG.BIT.EP0iPKTE = 1;
}

//EndPoint0(in)ɑ΂đMsB(񕪁j
void SendEP0iFirst( _UBYTE * ptrBuf, int size )
{
	//Mobt@̓]L
	ptrEP0i_Buf = ptrBuf;
	sizeEP0i_Buf = size;
	
	//EP0(in)̑MtOZbg
	USB_Proc_Flag.BIT.EP0iSending = 1;
	
	SendEP0iNext();
}

//USB֘ȀsB
void USB_Initalize(void)
{
	int loop;
	
	//USBW[𓮍삳B
	MSTP._CRC.BIT._USB		= 0;	//ԂUSBW[͒~ĂB

	//荞ݑIsB
	//͊荞݂̑I͊̂܂ܗp܂B
	
	//荞݃Cl[uݒsB
	//ŃCl[uɂtÓA荞ݏ̒
	//tOOɂȂ΁AɊ荞݂āAfbhbN̂ŒӁB
	USB.IER0.BIT.BRST 		= 1;	//oXZbg
	USB.IER0.BIT.EP1FULL 	= 1;	//EP1 FIFOt
	USB.IER0.BIT.SETUPTS	= 1;	//EP0 ZbgAbvR}hMivAvj
	USB.IER0.BIT.EP0oTS	    = 1;	//EP0 R}hM
	USB.IER0.BIT.EP0iTS		= 1;	//EP0 R}hM
	USB.IER1.BIT.VBUSF	    = 1;	//USBoXڑ
	
	USB.IER0.BIT.EP2EMPTY   = 0;	//EP2 obt@󂫊݂͑MJn܂ŋ֎~B
	USB.ISR0.BIT.EP2EMPTY	= 1;	//EP2 obt@󂫊݂́AUSBINIT3𗘗p܂B iPlug&Playƕׁ̈j
	
	//荞݃tOB
	//荞ݏۂɁAۂڍׂɒm̂ɕKv	
	USB.IFR0.BYTE			= 0;
	USB.IFR1.BYTE			= 0;
	USB.IFR2.BYTE			= 0;

	//dɁAPxGh|Cg񃌃WX^
	for( loop=0 ; loop < 5*10 ; loop++ )
	{
		USB.EPIR = EndPointInfo[loop];
	}

	//OUSBւ̕tOB
	USB_Proc_Flag.BYTE = 0;

	//SĂ̏񂾂AUSBzXgyуnuɐڑʒm܂B
	USB.DMAR.BIT.PULLUP_E = 1;	// D+[qvAbv
}


//USBINTN0荞ݏ
void USBINTN0_Proc(void)
{
	//Endpoint1(Bulk out)Mt荞
	sleep();
}

//USBINTN1荞ݏ
void USBINTN1_Proc(void)
{
	//Endpoint2(Bulk in)MGveB荞
	sleep();
}

//USBINTN2荞ݏ
void USBINTN2_Proc(void)
{
	//USBt@NVėp荞
	//Ŏ̊荞݂
	//BRST@	oXZbg
	//EP1 FULL	Endpoint1@FIFOt
	//SETUP TS	ZbgAbvR}hMiAvΉR}ĥ݁j
	//EP0o TS	Endpoint0 out M
	//EP0i TR	Endpoint0 in  ]NGXg
	//EP0i TS	Endpoint0 in  M
	
	//ނ̊荞݂ɏW񂳂̂ŁAIFRx̓eŏU蕪KvB


	//EP0iMꂽiMȂΗȂBj
	if( USB.IFR0.BIT.EP0iTS == 1)
	{
		USB.IFR0.BIT.EP0iTS = 0;
		//OMobt@ɖMf[^cĂ΁Aăf[^𑗐MB
		if( USB_Proc_Flag.BIT.EP0iSending == 1 )
		{
			SendEP0iNext();
		}
	}
	
	//USBoXZbgꂽ
	if( USB.IFR0.BIT.BRST == 1 )
	{
		USB.IFR0.BIT.BRST = 0;
		//USBڑꂽ܂܁AzXgnu烊Zbg𑗂ĂBi܂Ăj
		USB.FCLR.BYTE = 0x73;	//FIFOSăNAB
	}
	
	//Rg[R}hnŁAAvP[VŏKvȃR}h
	if( USB.IFR0.BIT.SETUPTS == 1 )
	{
		PM.DDR = 0;
		USB.IFR0.BIT.SETUPTS = 0;
		USB.FCLR.BIT.EP0iCLR = 1;		//EndPoint0̓FIFONA
		USB.FCLR.BIT.EP0oCLR = 1;		//EndPoint0̏oFIFONA

		SetupCommand.Buf[0] = USB.EPDR0s;
		SetupCommand.Buf[1] = USB.EPDR0s;
		SetupCommand.Buf[2] = USB.EPDR0s;
		SetupCommand.Buf[3] = USB.EPDR0s;
		SetupCommand.Buf[4] = USB.EPDR0s;
		SetupCommand.Buf[5] = USB.EPDR0s;
		SetupCommand.Buf[6] = USB.EPDR0s;
		SetupCommand.Buf[7] = USB.EPDR0s;
		USB.TRG.BIT.EP0sRDFN = 1;		//EP0(setup)FIFOobt@ǂݏo

		USB_Proc_Flag.BIT.Setup = 1;	//Mobt@Ɋi[瑱̓C
	}
	
	//EndPoint0(out)ŁAR}hʒmĂB
	if( USB.IFR0.BIT.EP0oTS == 1)
	{
		int readSize,loop;
		USB.IFR0.BIT.EP0oTS = 0;

		readSize = USB.EPSZ0o;
		for( loop = 0; loop < readSize ; loop++ )
		{
			ControlCommandBuf[loop] = USB.EPDR0o;
		}
		USB.TRG.BIT.EP0oRDFN = 1;
	}
	
	//EndPoint1(out)ɃpPbg
	if( USB.IFR0.BIT.EP1FULL )
	{
		int size;
		size = USB.EPSZ1;
		
		//M̃pPbgf[^AMp[vobt@֊i[B
		while( size -- > 0 )
		{
			RcvBuf[RcvStorePoint++] = USB.EPDR1;
			//[vobt@Ȃ̂ŁAobt@̍Ō܂ł䂭ƕۑ|C^擪ֈړB
			//AǂݏoĂȂf[^cĂ΁A㏑BiI[o[͖؁j
			if( RcvStorePoint >= RcvLimit )
			{
				RcvStorePoint =0;
			}
		}
		//FIFO𔽓]B
		//̓ǂݍłŒɍXɃpPbgMĂ΁A
		//]ɂɂ܂ǂݍ݂sKvB
		//̍ۂ́AĂѓ荞݂ČĂяoB
		USB.TRG.BIT.EP1RDFN = 1;

		//CŎMd͂B
		USB_Proc_Flag.BIT.EP1Received = 1;
		
		//d_ŖM̕ԐMd͑SĔjB
		RemainSendSize =0;	
		USB.FCLR.BIT.EP2CLR = 1;		//EP2Mobt@NAB

	}
}

//USBINTN3荞ݏ
void USBINTN3_Proc(void)
{
	//USBt@NVėp荞
	//Ŏ̊荞݂
	//EP3 TR	Endpoint3 in MNGXg
	//EP3 TS	Endpoint3 in M
	//VBUSF		USBoXڑ
	//SURSE		TXyhEW[o
	//CFDN		Gh|Cg񃍁[hI
	//SETCE		Set Configration R}ho
	//SETIT		Set InterfaceR}ho
	//ނ̊荞݂ɏW񂳂̂ŁAIFRx̓eŏU蕪KvB
	

	//USBoXɐڑꂽႵ́Aؒfꂽ̂B
	if( USB.IFR1.BIT.VBUSF == 1 )
	{
		// VBUSC̏󋵂ɂāAڑؒf𔻒fB
		if( USB.IFR1.BIT.VBUSMN == 1 )
		{
			//ڑꂽ̏
			//TODO//
		}
		else
		{
			//ؒfꂽ̏
			//TODO//
		}
		USB.IFR1.BIT.VBUSF = 0;		//Y荞ݗvNA

		//FIFOSăNAB
		USB.FCLR.BYTE = 0x73;
	}

	//ʐMs󋵂ɂȂɁAoNC]݂̂ŁA
	//oNC]obt@󂫊݂ĂȂƃobt@󏈗sȂB
	if( USB.IER0.BIT.EP2EMPTY == 1 )
	{
		if( USB.IFR0.BIT.EP2EMPTY == 1 )
		{
	 		//Mf[^ɑ̂łΗobt@ɃZbgB
			int sizeLimit = 64;
			int sendFlag = 0;
	
			PA.DR.BIT.B1 = 1;
	
			//EP2FIFOobt@1pPbg̃f[^ݒ
			while( (RemainSendSize > 0) && ( sizeLimit-- > 0)  )
			{
				USB.EPDR2 = *ptrSendPos;
				ptrSendPos++;
				RemainSendSize--;
				sendFlag = 1;
			}
			//EP2 USoCgobt@̎c̗̈ɂ0𖄂߂
			//while( sizeLimit -- > 0 )
			//{
			//	USB.EPDR2 = 0;
			//}
		
			//FIFOobt@ɑIAMJnB
			if( sendFlag == 1 )
			{
				USB.TRG.BIT.EP2PKTE = 1;
			}
			else
			{
				USB.IER0.BIT.EP2EMPTY = 0;	//MI犄݂֎~BiIFR0.EP2EMPTY̓NA邱ƂoȂׁj
			}
			PA.DR.BIT.B1 = 0;
		}
	}
}

//RESUME USB荞ݏ
void USBINTRESUME_Proc(void)
{
	//USBnuAX^oC[h̃W[vȂꂽB
	sleep();
}


//USB@\̃C
void USB_Proc( void )
{
	int bufSize,rqSize;
	
	//SetupCommandnUSBW[IɏȂR}hB
	if( USB_Proc_Flag.BIT.Setup == 1 )
	{
		//GET_DISCRIPTORR}h̏
		if( ( SetupCommand.Format.bmRequestType.DataTransferDirection == 1  ) && // f[^擾
		    ( SetupCommand.Format.bmRequestType.Type == 0 ) &&					 // Wn
			( SetupCommand.Format.bmRequestType.Recipient == 0 ) &&				 // foCX
			( SetupCommand.Format.bRequest == 6 ))								 // GET_DESCRIPTOR
		{
			//8rbgDescriptor Typew肳ĂB
			//Ai[ɏʁEʂ̃oCgւēĂ̂ŁA
			//vOł́A8rbgŔ肷B
			switch( SetupCommand.Format.wValue & 0xFF )
			{
				case 1:	//Device
					SendEP0iFirst( StandardDeviceDescriptor , sizeof(StandardDeviceDescriptor) );
				break;

				case 2: //Configuration
					bufSize =	sizeof(StandardConfigurationDescriptor)+
							sizeof(StandardInterfaceDescriptor)+
							sizeof(StandardEndpointDescriptor1)+
							sizeof(StandardEndpointDescriptor2);
					rqSize = rotlw(8,SetupCommand.Format.wLength);

					// Configration͍ŏConfigration̂ݓǂݏoāA
					// ̌Configration+Interface+Endpoint̑SĂĂьĂяoB
					// ̍ہAwLength  HostMTCYĂ̂ŁA
					// ̃TCY𒴂Ȃ悤ɑMKvB
										
					if( rqSize < bufSize )
					{
						bufSize = rqSize;
					}
					SendEP0iFirst( StandardConfigurationDescriptor , bufSize );
				break;


				case 3: //String
					//TODO String Descriptor Lqۂɂ͂ɏ
				break;
				case 4: //Interface
					SendEP0iFirst( StandardInterfaceDescriptor , sizeof(StandardInterfaceDescriptor) );
				break;
				case 5: //Endpoint
					//8rbgɂǂ̃Gh|Cg̏擾̂Indexn̂ŁAQ
					//AvOł͏ʁEʂւĂ̂ŁA8rbgŔ肷B
					switch( (SetupCommand.Format.wValue >> 8) & 0xFF )
					{
						case 1:	// Endpoint 1 fBXNv^
							SendEP0iFirst( StandardEndpointDescriptor1 , sizeof(StandardEndpointDescriptor1) );
						break;
						case 2:	// Endpoint 2 fBXNv^
							SendEP0iFirst( StandardEndpointDescriptor2 , sizeof(StandardEndpointDescriptor2) );
						break;
					}
				break;
				case 6: //Device_Qualifier
					//TODO Device_Qualifier Lqۂɂ͂ɏ
				break;
				case 7: //Other_Speed_Configuration
					//TODO Other_Speed_Configuration Lqۂɂ͂ɏ
				break;
				case 8:	//Interface_Power
					//TODO Device_Qualifier Lqۂɂ͂ɏ
				break;
			} 
		}
		else
			
		//SET_DISCRIPTORR}h̏
		if( ( SetupCommand.Format.bmRequestType.DataTransferDirection == 0  ) && // f[^ݒ
		    ( SetupCommand.Format.bmRequestType.Type == 0 ) &&					 // Wn
			( SetupCommand.Format.bmRequestType.Recipient == 0 ) &&				 // foCX
			( SetupCommand.Format.bRequest == 7 ))								 // SET_DESCRIPTOR
		{
			//TODO//
			sleep();
		}
		else

		//SYNC_FRAMER}h̏
		if( ( SetupCommand.Format.bmRequestType.DataTransferDirection == 1  ) && // f[^擾
		    ( SetupCommand.Format.bmRequestType.Type == 0 ) &&					 // Wn
			( SetupCommand.Format.bmRequestType.Recipient == 2 ) &&				 // Gh|Cg
			( SetupCommand.Format.bRequest == 12 ))								 // SYNC_FRAME
		{
			//TODO//
			sleep();
		}
		else
		{
			//Endpoint0ɗ\zOInΏ𒆒fB
			//Endpoint0gOʐM͂ȂA
			//gꍇɂ́AEndpoint0(out),Endpoint0(in)gʐMB
			sleep();
		}
		
		//SetupCommand̎MIB
		USB_Proc_Flag.BIT.Setup = 0;

		PM.DDR = 8;
	}
}


//Mobt@APdoB
// CommandBuf : d̊i[obt@iTCY̓vgRdlŒ`)
// Delimiter  : Pd̏IR[hiR[h̓vgRdlŒ`j
// ߂l	  : dBAf~^oȂǓdsɂ0
int GetCommandFromReceiveBuf( unsigned char *CommandBuf, char Delimiter )
{
	int size = 0;
	int CurrentPos = RcvExtractPoint;
	
	//݃|CgƁAǂݏo|CgȂ܂őB
	while( CurrentPos != RcvStorePoint )
	{
		*CommandBuf++ = RcvBuf[CurrentPos];

		size++;
		// f~^ꂽ̂ŁA܂ł1dƂĊB
		// Ǐo|Cg܂Ői߂B
		if( RcvBuf[CurrentPos++] == Delimiter )
		{
			//ǏóAf~^̒ォB
			//1dMĂȂ̂Ȃ΁Aۑ|CgƓʒuɂȂB
			RcvExtractPoint = CurrentPos;
			
			//MԂB
			return size;
		}

		//[vobt@Ȃ̂ŁAobt@̍Ō܂ł䂭ƓǍ݃|C^擪ֈړB
		if( CurrentPos >= RcvLimit )
		{
			CurrentPos =0;
		}
	}
	
	//f~^𔭌łȂAMf[^΂ʂB
	return 0;
}

//d𑗐MB(Qʃobt@Mj
//d́AH8SXBulk]FIFOőeʂ64oCgŋ؂
//BulkOut]̂Qʃobt@pāAd𑗐MB
void SetCommandToSendBuf( _UBYTE *CommandBuf, _UINT size )
{
	//PC̑MvAobt@̒g]B
	//LUSB݂ōsÄׂ̏sB
	
	RemainSendSize = size;
	ptrSendPos = CommandBuf;

	//EP2 obt@󂫊݂JnB
	USB.IER0.BIT.EP2EMPTY   = 1;	

}
